.module Music_System

.globl cpct_akp_musicInit_asm
.globl cpct_akp_SFXInit_asm
.globl cpct_akp_SFXPlay_asm
.globl cpct_akp_SFXStopAll_asm
.globl cpct_akp_stop_asm
.globl _songs
.globl _sfx
.globl _menu
.include "cpctelera.h.s"
.globl cpct_isKeyPressed_asm

music_muted:: .db 0
mute_pressed: .db 0

current_song: .dw _menu

check_if_mute::
    ld hl, #Key_M               ; Si se pulsa la tecla 'M'
    call cpct_isKeyPressed_asm
    jp z, toggle_mute_no_pressed
        ld a,(mute_pressed)
        cp #1
        jp z,toggle_mute
        call sys_music_mute
        ld a,#1
        ld (mute_pressed),a
        jp toggle_mute
    toggle_mute_no_pressed:
        ld a,#0
        ld (mute_pressed),a
    toggle_mute:
ret

sys_music_init::
    call sys_music_set_menu
    ld de, #_sfx
    call cpct_akp_SFXInit_asm
ret
sys_music_set_menu::
    ld hl,#_menu
    ld (current_song),hl
    ld a,(music_muted)
    cp #0
    jp nz,saltar_init_music_menu
    ld de, #_menu
    call cpct_akp_musicInit_asm
    saltar_init_music_menu:
ret
sys_music_set_music::
    ld hl,#_songs
    ld (current_song),hl
    ld a,(music_muted)
    cp #0
    jp nz,saltar_init_music_music
    ld de, #_songs
    call cpct_akp_musicInit_asm
    saltar_init_music_music:
ret
;INSTRUMENT NO
;1:Shot
;2:Hit
;3:PlayerHit
;4:Powerup

;(1B L ) sfx_num	Number of the instrument in the SFX Song (>0), same as the number given to the instrument in Arkos Tracker.
;(1B H ) volume	Volume [0-15], 0 = off, 15 = maximum volume.
;(1B E ) note	Note to be played with the given instrument [0-143]
;(1B D ) speed	Speed (0 = As original, [1-255] = new Speed (1 is fastest))
;(2B BC) inverted_pitch	Inverted Pitch (-0xFFFF -> 0xFFFF).  0 is no pitch.  The higher the pitch, the lower the sound.
;(1B A ) channel_bitmask	Bitmask representing channels to use for reproducing the sound (Ch.A = 001 (1), Ch.B = 010 (2), Ch.C = 100 (4))

sys_music_play_shot::
    exx
    call cpct_akp_SFXStopAll_asm
    ld l,#1
    ld h,#15
    ld e,#46
    ld d,#4
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm
    exx
ret
sys_music_play_hit::
    exx
    call cpct_akp_SFXStopAll_asm
    ld l,#2
    ld h,#15
    ld e,#46
    ld d,#0
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm
    exx
ret
sys_music_play_playerHit::
    exx
    call cpct_akp_SFXStopAll_asm
    ld l,#3
    ld h,#15
    ld e,#46
    ld d,#0
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm
    exx
ret
sys_music_play_powerup::
    exx
    call cpct_akp_SFXStopAll_asm
    ld l,#4
    ld h,#15
    ld e,#48
    ld d,#0
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm
    exx
ret

sys_music_mute::
    ld a,(music_muted)
    xor #1
    ld (music_muted),a
    cp #1
    jp z,mute
    unmute:
        ld de, (current_song)
    jp finish_mute
    mute:
        ld de, #_sfx
    finish_mute:
    call cpct_akp_musicInit_asm
ret